#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <optarg.h>

#define HEX 1
#define DEZ 2
#define OCT 3
#define BIN 4

void tobin (unsigned long number) {
  int remainder;
  unsigned long quotient;
  
  /*
   * some recursion ... 
   */	
  remainder = number % 2;
  quotient = number / 2;
  if (quotient != 0) {
    tobin (quotient);
  }
  printf ("%d", remainder);
}

void main (int argc, char *argv) {
  unsigned long number;
  int c, format;
  char *s;
  
  while((c = getopt(argc, argv, "d:o:x:b:")) != EOF){
    switch(c){
    case 'd':

      format = DEZ;
      s = optarg;	
      break;
    case 'o':	
      format = OCT;	
      s = optarg;	
      break;
    case 'x':
      format = HEX;
      s = optarg;
      break;
    case 'b':
      format = BIN;
      s = optarg;
      break;
    default:
      printf ("unknown format %c\n", c);
      exit (-1);
    }
  }
  sscanf (s, "%li", &number);
  switch (format) {
  case DEZ:
    printf ("%lu\n", number);
    break;
  case OCT:
    printf ("0%lo\n", number);
    break;
  case HEX:
    printf ("0X%lX\n", number);
    break;
  case BIN:
    tobin (number);
    printf ("b\n");
    break;
  }
}      
	

